unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    continued_fraction_btn1: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    tanx2_btn: TButton;
    continued_fraction_btn2: TButton;
    Tanx3_btn: TButton;
    tanx1_btn: TButton;
    Edit3: TEdit;
    LnX1_Btn: TButton;
    LnX2_btn: TButton;
    procedure continued_fraction_btn1Click(Sender: TObject);
    procedure tanx2_btnClick(Sender: TObject);
    procedure continued_fraction_btn2Click(Sender: TObject);
    procedure Tanx3_btnClick(Sender: TObject);
    procedure tanx1_btnClick(Sender: TObject);
    procedure LnX1_BtnClick(Sender: TObject);
    procedure LnX2_btnClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses Velthuis.Bigdecimals, Velthuis.BigIntegers, math;

//--------------------------------------------------------------
// tan̘AWJvZ
// tan(x)  x radian

// tan(x) = x /
//             1 - x^2 /
//                       3 -  x^2 /   5,7,9
procedure TForm1.tanx1_btnClick(Sender: TObject);
const
  N = 15;
var
  i : integer;
  x, t : double;
  c, b : array[0..N - 1] of double;

  // tan(x)
  function ascend(n: integer): double;
  var
    f, bk : double;
    k : integer;
  begin
    bk := 0;
    f := 0;                         // l
    for k := n  downto 0 do begin   // 납vZ
      bk := b[k] + f;
      if bk = 0 then break;
      f := c[k] / bk;
    end;
    if bk = 0 then result := infinity
              else result := f;
  end;

begin
  val(edit2.Text, x, i);
  if i <> 0 then begin
    application.MessageBox('͒lɊԈႢL܂B','',0);
    exit;
  end;
  memo1.Clear;
  c[0] := x;
  for i := 1 to N - 1 do c[i] := -x * x;            // x, -x^2, -x^2,  EEE
  for i := 0 to N - 1 do b[i] := 2 * (i + 1) - 1;   // 1, 3, 5, 7, EEE 
  t := ascend(N - 1);                                   // AvZ
  Memo1.Lines.Append('tan(x) = ' + floattostr(t));
end;

// tan(x)
// rʏo͂
procedure TForm1.tanx2_btnClick(Sender: TObject);
const
  N = 18;
var
  i : integer;
  x, t : double;

  // tan(x) vZroߏo͂
  function descend(x: double; n: integer): double;
  var
    i : integer;
    p1, q1, p2, q2, p3, q3 : double;
    ci, bi, p2b : double;
  begin
    p1 := 1;                              // l q1
    q1 := 0;                              // l 1
    p2 := 0;                              // l q2
    q2 := 1;                              // l 2
    p2b := 0;
    for i := 1 to n do begin              // 擪vZ
      if i = 1 then ci := x               // ci= x, -x^2, -x^2 EEE
               else ci := -x * x;
      bi := 2 * i - 1;                    // bi= 1,3,5,7,9EEE
      p3 := p1 * ci + p2 * bi;            // qvZ
      p1 := p2;
      p2 := p3;
      q3 := q1 * ci + q2 * bi;            // vZ
      q1 := q2;
      q2 := q3;
      if q2 <> 0 then begin               // ꂪ[łȂ
        p1 := p1 / q2;
        q1 := q1 / q2;
        p2 := p2 / q2;
        q2 := 1;
        Form1.Memo1.Lines.Append(inttostr(i) + ': ' + floattostr(p2));
        if p2b = p2 then break;           // lI
        p2b := p2;
      end
      else begin                          // ꂪ[
        Form1.Memo1.Lines.Append('');
        break;
      end;
    end;
    if q2 <> 0 then result := p2 else result := infinity;
  end;

begin
  val(edit2.Text, x, i);
  if i <> 0 then begin
    application.MessageBox('͒lɊԈႢL܂B','',0);
    exit;
  end;
  memo1.Clear;
  t := descend(x, N);                        // rʏo͂vZ
  Memo1.Lines.Append('tan(x) =' + floattostr(t));
end;

// tan(x) ċA[vvZ
procedure TForm1.Tanx3_btnClick(Sender: TObject);
var
  x, t : double;
  ch : integer;

  // x   radian
  // x2  x^2
  // t  A
  // n ċN n1/2    n ͊@
  function drTan(x, x2, t: double; n: integer): double;
  begin
    if n - t = 0 then t := infinity
                 else t := x2 / (n - t);
    n := n - 2;
    if (n <= 1) then begin
      if (1 - t) = 0 then result := infinity
                     else result := x / (1 - t);
    end
    else
      result := drTan(x, x2, t, n);
  end;

begin
  val(edit2.Text, x, ch);
  if ch <> 0 then begin
    application.MessageBox('͒lɊԈႢL܂B','',0);
    exit;
  end;
  memo1.Clear;
  t := drtan(x, x * x, 0, 21);                   // ċNvZ
  Memo1.Lines.Append('ċA[vvZ');
  Memo1.Lines.Append('tan(x) =' + floattostr(t));
end;

//-------------------------------------------------------------------------
// ln(x)
// ln(1+x) = x/
//            1+x/
//               2+x/
//                  3+2x/
//                      2+2x/
//                          5+3x/
//                              2+3x/
//                                  7+   EEE
procedure TForm1.LnX1_BtnClick(Sender: TObject);
const
  N = 28;
var
  xin, x : double;
  ch : integer;
  t, Lnx : double;

  // ΐ֐ ċA 납vZ
  function drLog(x: double; n: integer; t: double): double;
  var
    n2 :Integer;
    x2 :double;
  begin
    n2 := n;
    x2 := x;
    if (n > 3) then
    begin
      if (n mod 2 = 0) then n2 := 2;
      x2 := x * (n div 2);
    end;
    t := x2 / (n2 + t);

    if (n <= 2) then result := x / (1 + t)
                else result := drLog(x, n - 1, t);
  end;

begin
  val(edit3.Text, xin, ch);                         // ͒lmF
  if ch <> 0 then begin
    application.MessageBox('͒lɊԈႢL܂B','',0);
    exit;
  end;
  if xin <= 0 then begin
    application.MessageBox('ȓ͂łB','',0);
    exit;
  end;
  Memo1.Clear;
  t := 0;
  x := xin - 1;
  LnX := drLog(x, n, t);
  Memo1.Lines.Append('ċAvZ');
  Memo1.Lines.Append('Len(x) =' + floattostr(Lnx));
end;

// ln(x)
// ln(1+x) = x/
//            1+1^2x/
//                  2+1^2x/
//                        3+2^2/
//                             4+2^2/
//                                  5+3^2x/
//                                        6+3^2x/
//                                              7+4^2/
//                                                   8+4^2/
//                                                        9+ EEEEE
procedure TForm1.LnX2_btnClick(Sender: TObject);
const
  N = 28;
var
  xin : double;
  ch : integer;
  Lnx : double;

  // ln(x)
  function drln(x: double; n: integer): double;
  var
    nx, i : integer;
    t : double;
  begin
    t := 0;
    for i := n downto 2 do begin              // n -> 2  납vZ
      nx := i div 2;
      t := nx * nx * x / (i + t)
    end;
    result := x / (1 + t);                    // n=1
  end;

begin
  val(edit3.Text, xin, ch);                         // ͒lmF
  if ch <> 0 then begin
    application.MessageBox('͒lɊԈႢL܂B','',0);
    exit;
  end;
  if xin <= 0 then begin
    application.MessageBox('ȓ͂łB','',0);
    exit;
  end;
  Memo1.Clear;
  Lnx := drln(xin - 1, 28);
  Memo1.Lines.Append('Len(x) =' + floattostr(Lnx));
end;

//-------------------------------------------------------------------------

// ̘A
procedure TForm1.continued_fraction_btn1Click(Sender: TObject);
var
  xin : double;
  x, b, a, t, one : bigdecimal;
  ch : integer;
begin
  val(edit1.Text, xin, ch);                         // ͒lmF
  if ch <> 0 then begin
    application.MessageBox('͒lɊԈႢL܂B','',0);
    exit;
  end;
  memo1.Clear;
  memo1.Lines.Append('l = ' + floattostr(xin));
  x := edit1.Text;
  b := x;
  t := '1e-30';                                     // l
  one := '1';
  while True do begin
    a := b.Int;                                     // ؂̂
    memo1.Lines.Append(a.ToPlainString + '+1/');
    b := b - a;                                     // ̂ݎo
    if bigdecimal.Abs(b) < t then break;
    b := one / b;
  end;
end;

// ̘A
procedure TForm1.continued_fraction_btn2Click(Sender: TObject);
var
  a : array of bigdecimal;              // A
  t : array of array of bigdecimal;     //  q
  xb : bigdecimal;
  k : integer;
  s : string;
  xin : double;

  procedure ContFrac(x : bigdecimal);   // AvZ
  const
    M = 32;                            // ő僋[v
  var
    b, one, h : bigdecimal;
    i : integer;
  begin
    one := '1';
    h := '1e-30';                     // l
    for i := 1 to M do begin
      b := x.Int;                     // _ȉ؂̂
      setlength(a, i);
      a[i - 1] := b;                  // A za
      x := x - b;                     // x̏
      if bigdecimal.Abs(x) < h then break;
      x := one / x;
    end;
  end;

  procedure ApproximateRatio;         // ߎ()vZ q & @
  var
    p0, p1, p2 : bigdecimal;
    q0, q1, q2 : bigdecimal;
    one : bigdecimal;
    i, j, k : integer;
  begin
    one := '1';
    p0 := a[0];                       // q
    q0 := one;                        // 
    p1 := a[1] * p0 + one;
    q1 := a[1];
    j := length(a);
    setlength(t, j, 2);
    t[0, 0] := p0;                    // q
    t[0, 1] := q0;                    // 
    t[1, 0] := p1;
    t[1, 1] := q1;
    delete(a, 0 , 2);                 // za 擪2폜
    j := length(a);
    for k := 0 to j - 1 do begin
      p2 := a[k] * p1 + p0;           // q
      q2 := a[k] * q1 + q0;           // 
      i := k + 2;
      t[i, 0] := p2;                  // q
      t[i, 1] := q2;                  // 
      p0 := p1;
      p1 := p2;
      q0 := q1;
      q1 := q2;
    end;
  end;

begin
  val(edit1.Text, xin, k);            // ͒lmF
  if k <> 0 then begin
    application.MessageBox('͒lɊԈႢL܂B','',0);
    exit;
  end;
  Memo1.Clear;
  memo1.Lines.Append('l = ' + floattostr(xin));

  xb := edit1.Text;
  ContFrac(xb);                       // AvZ ʔza
  s := '';
  for xb in a do s := s + xb.ToPlainString + '+1/ ';
  memo1.Lines.Append(s);

  ApproximateRatio;                   // A番 qvZ ʔzt
  for k := 0 to length(t) - 1 do begin
    if t[k, 0] <> bigdecimal.Zero then begin     // [\'0.0'̈׃[ȊO\
      xb := t[k, 0] / t[k, 1];
      xb := xb.RoundToScale(20, rmNearestUp);    // _ȉ20Ŋۂ
      xb := xb.RemoveTrailingZeros(1);           // svȃ[폜
      s := xb.ToPlainString;
    end
    else s := '0.0';
    memo1.Lines.Append(t[k, 0].ToPlainString +' / ' + t[k, 1].ToPlainString + ' = ' + s);
  end;
end;

end.
